Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config	(revision 11650)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config	(revision 11651)
@@ -80,10 +80,4 @@
       <setting name="PluginInfrastructureDll" serializeAs="String">
         <value>HeuristicLab.PluginInfrastructure-3.3.dll</value>
-      </setting>
-      <setting name="SharpZipLibDll" serializeAs="String">
-        <value>ICSharpCode.SharpZipLib.dll</value>
-      </setting>
-      <setting name="SharpZipLibLicense" serializeAs="String">
-        <value>ICSharpCode.SharpZipLib License.txt</value>
       </setting>
       <setting name="ClientsHiveSlaveCoreDll" serializeAs="String">
Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config	(revision 11650)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config	(revision 11651)
@@ -80,10 +80,4 @@
       <setting name="PluginInfrastructureDll" serializeAs="String">
         <value>HeuristicLab.PluginInfrastructure-3.3.dll</value>
-      </setting>
-      <setting name="SharpZipLibDll" serializeAs="String">
-        <value>ICSharpCode.SharpZipLib.dll</value>
-      </setting>
-      <setting name="SharpZipLibLicense" serializeAs="String">
-        <value>ICSharpCode.SharpZipLib License.txt</value>
       </setting>
       <setting name="ClientsHiveSlaveCoreDll" serializeAs="String">
Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj	(revision 11650)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj	(revision 11651)
@@ -183,9 +183,4 @@
     <None Include="HeuristicLab.snk" />
   </ItemGroup>
-  <ItemGroup>
-    <Content Include="ICSharpCode.SharpZipLib License.txt">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </Content>
-  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: unk/sources/HeuristicLab.Clients.Hive.Slave/3.3/ICSharpCode.SharpZipLib License.txt
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/ICSharpCode.SharpZipLib License.txt	(revision 11650)
+++ 	(revision )
@@ -1,13 +1,0 @@
-#ziplib (SharpZipLib, formerly NZipLib) is a Zip, GZip, Tar and BZip2 library written entirely in C# for the .NET platform. It is implemented as an assembly (installable in the GAC), and thus can easily be incorporated into other projects (in any .NET language). The creator of #ziplib put it this way: "I've ported the zip library over to C# because I needed gzip/zip compression and I didn't want to use libzip.dll or something like this. I want all in pure C#."
-
-License
-
-The library is released under the GPL with the following exception:
-
-Linking this library statically or dynamically with other modules is making a combined work based on this library. Thus, the terms and conditions of the GNU General Public License cover the whole combination.
-
-As a special exception, the copyright holders of this library give you permission to link this library with independent modules to produce an executable, regardless of the license terms of these independent modules, and to copy and distribute the resulting executable under terms of your choice, provided that you also meet, for each linked independent module, the terms and conditions of the license of that module. An independent module is a module which is not derived from or based on this library. If you modify this library, you may extend this exception to your version of the library, but you are not obligated to do so. If you do not wish to do so, delete this exception statement from your version.
-
-Note: The exception is changed to reflect the latest GNU Classpath exception. Older versions of #ziplib did have another exception, but the new one is clearer and it doesn't break compatibility with the old one.
-
-Bottom line: In plain English this means you can use this library in commercial closed-source applications.
Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/PluginManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/PluginManager.cs	(revision 11650)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/PluginManager.cs	(revision 11651)
@@ -113,6 +113,4 @@
       string baseDir = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);
       CopyFile(baseDir, targetDir, CoreProperties.Settings.Default.PluginInfrastructureDll);
-      CopyFile(baseDir, targetDir, CoreProperties.Settings.Default.SharpZipLibDll);
-      CopyFile(baseDir, targetDir, CoreProperties.Settings.Default.SharpZipLibLicense);
 
       // copy slave plugins, otherwise its not possible to register the UnhandledException handler to the appdomain        
Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.Designer.cs	(revision 11650)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.Designer.cs	(revision 11651)
@@ -86,28 +86,4 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("ICSharpCode.SharpZipLib.dll")]
-        public string SharpZipLibDll {
-            get {
-                return ((string)(this["SharpZipLibDll"]));
-            }
-            set {
-                this["SharpZipLibDll"] = value;
-            }
-        }
-        
-        [global::System.Configuration.UserScopedSettingAttribute()]
-        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("ICSharpCode.SharpZipLib License.txt")]
-        public string SharpZipLibLicense {
-            get {
-                return ((string)(this["SharpZipLibLicense"]));
-            }
-            set {
-                this["SharpZipLibLicense"] = value;
-            }
-        }
-        
-        [global::System.Configuration.UserScopedSettingAttribute()]
-        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
         [global::System.Configuration.DefaultSettingValueAttribute("HeuristicLab.Clients.Hive.SlaveCore-3.3.dll")]
         public string ClientsHiveSlaveCoreDll {
Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings	(revision 11650)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings	(revision 11651)
@@ -17,10 +17,4 @@
     <Setting Name="PluginInfrastructureDll" Type="System.String" Scope="User">
       <Value Profile="(Default)">HeuristicLab.PluginInfrastructure-3.3.dll</Value>
-    </Setting>
-    <Setting Name="SharpZipLibDll" Type="System.String" Scope="User">
-      <Value Profile="(Default)">ICSharpCode.SharpZipLib.dll</Value>
-    </Setting>
-    <Setting Name="SharpZipLibLicense" Type="System.String" Scope="User">
-      <Value Profile="(Default)">ICSharpCode.SharpZipLib License.txt</Value>
     </Setting>
     <Setting Name="ClientsHiveSlaveCoreDll" Type="System.String" Scope="User">
Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/app.config
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/app.config	(revision 11650)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/app.config	(revision 11651)
@@ -80,10 +80,4 @@
       <setting name="PluginInfrastructureDll" serializeAs="String">
         <value>HeuristicLab.PluginInfrastructure-3.3.dll</value>
-      </setting>
-      <setting name="SharpZipLibDll" serializeAs="String">
-        <value>ICSharpCode.SharpZipLib.dll</value>
-      </setting>
-      <setting name="SharpZipLibLicense" serializeAs="String">
-        <value>ICSharpCode.SharpZipLib License.txt</value>
       </setting>
       <setting name="ClientsHiveSlaveCoreDll" serializeAs="String">
Index: /trunk/sources/HeuristicLab.Services.Hive.JanitorService/3.3/HeuristicLab.Services.Hive.JanitorService-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Services.Hive.JanitorService/3.3/HeuristicLab.Services.Hive.JanitorService-3.3.csproj	(revision 11650)
+++ /trunk/sources/HeuristicLab.Services.Hive.JanitorService/3.3/HeuristicLab.Services.Hive.JanitorService-3.3.csproj	(revision 11651)
@@ -141,9 +141,4 @@
     </EmbeddedResource>
   </ItemGroup>
-  <ItemGroup>
-    <Content Include="ICSharpCode.SharpZipLib License.txt">
-      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
-    </Content>
-  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: unk/sources/HeuristicLab.Services.Hive.JanitorService/3.3/ICSharpCode.SharpZipLib License.txt
===================================================================
--- /trunk/sources/HeuristicLab.Services.Hive.JanitorService/3.3/ICSharpCode.SharpZipLib License.txt	(revision 11650)
+++ 	(revision )
@@ -1,13 +1,0 @@
-#ziplib (SharpZipLib, formerly NZipLib) is a Zip, GZip, Tar and BZip2 library written entirely in C# for the .NET platform. It is implemented as an assembly (installable in the GAC), and thus can easily be incorporated into other projects (in any .NET language). The creator of #ziplib put it this way: "I've ported the zip library over to C# because I needed gzip/zip compression and I didn't want to use libzip.dll or something like this. I want all in pure C#."
-
-License
-
-The library is released under the GPL with the following exception:
-
-Linking this library statically or dynamically with other modules is making a combined work based on this library. Thus, the terms and conditions of the GNU General Public License cover the whole combination.
-
-As a special exception, the copyright holders of this library give you permission to link this library with independent modules to produce an executable, regardless of the license terms of these independent modules, and to copy and distribute the resulting executable under terms of your choice, provided that you also meet, for each linked independent module, the terms and conditions of the license of that module. An independent module is a module which is not derived from or based on this library. If you modify this library, you may extend this exception to your version of the library, but you are not obligated to do so. If you do not wish to do so, delete this exception statement from your version.
-
-Note: The exception is changed to reflect the latest GNU Classpath exception. Older versions of #ziplib did have another exception, but the new one is clearer and it doesn't break compatibility with the old one.
-
-Bottom line: In plain English this means you can use this library in commercial closed-source applications.